#pragma once

#include <SFML/Graphics.hpp>
#include "State.hpp"
#include "AnimatedSprite.hpp"

class StateSplash: public State {
public:
	enum SplashType {
		MAIN, INSTRUCTION, VICTORY
	};
public:
	StateSplash() = delete;
	StateSplash(SplashType type);
	virtual ~StateSplash();
	void onEvent(sf::Event event) final;
	void onUpdate(float dt) final;
	void onRender() final;
	State* next() const final;
private:
	void switchTo(SplashType type);
	AnimatedSprite m_sprite;
	SplashType m_type;
};

