#include "Asset.hpp"
#include "Renderer.hpp"
#include "StateSplash.hpp"
#include "StateIngame.hpp"
#include "Log.hpp"

StateSplash::StateSplash(SplashType type) {
	switchTo(type);
	Renderer::registerDrawable(&m_sprite, 101000, Renderer::Mode::UI);

	m_sprite.addAnimation("data/splash10.png", 1000, "main", true, 1280, 720);
	m_sprite.setAnimation("main");
	m_sprite.setAnimationSpeed(1.f);

	Log(INFO, "Splash state up");
	stateReady();
}

StateSplash::~StateSplash() {
	Renderer::deregisterDrawable(&m_sprite);

	Log(INFO, "Splash state down");
}

void StateSplash::onEvent(sf::Event event) {
	if (event.type == sf::Event::MouseButtonReleased || event.type == sf::Event::KeyReleased || event.type == sf::Event::JoystickButtonReleased) {
		switch (m_type) {
		case MAIN:
			stateFin();
			break;
		case INSTRUCTION:
		case VICTORY:
			stateFin();
			stateDie(); 
			break;
		}
	}
}

void StateSplash::onUpdate(float dt) {
	m_sprite.animate();
	static float a = 255.f;
	static float b = 0.f;

	b += dt;

	if (isFin()) {
		m_sprite.setColor(sf::Color(255, 255, 255, int(a -= dt * 100.f)));
		
		if (a < 5) {
			stateDie();
		}
	}
}

void StateSplash::onRender() {

}

void StateSplash::switchTo(SplashType type) {
	m_type = type;
	/*switch (m_type) {
	case MAIN:
		m_sprite.setAnimation("main");
		//m_sprite.setTexture(Asset::texture("data/splash3.png"));
		break;
	//case INSTRUCTION:
	//	m_sprite.setTexture(Asset::texture("data/splash.png"));
	//	break;
	//case VICTORY:
	//	m_sprite.setTexture(Asset::texture("data/splash2.png"));
	//	break;
	}*/
}

State* StateSplash::next() const {
	return new StateIngame();
}